    // Listing 10.12

    // Returning the dereferenced this pointer


    typedef unsigned short  USHORT;

    #include <iostream.h>


    class Counter

    {

    public:

      Counter();

      ~Counter(){}

      USHORT GetItsVal()const { return itsVal; }

      void SetItsVal(USHORT x) {itsVal = x; }

      const Counter& operator++ ();      // prefix

      const Counter operator++ (int); // postfix


   private:

      USHORT itsVal;

   };


   Counter::Counter():

   itsVal(0)

   {}


   const Counter& Counter::operator++()

   {

      ++itsVal;

      return *this;

   }


   const Counter Counter::operator++(int)

   {

      Counter temp(*this);

      ++itsVal;

      return temp;

   }


   int main()

   {

      Counter i;

      cout << "The value of i is " << i.GetItsVal() << endl;

      i++;

      cout << "The value of i is " << i.GetItsVal() << endl;

      ++i;

      cout << "The value of i is " << i.GetItsVal() << endl;

      Counter a = ++i;

      cout << "The value of a: " << a.GetItsVal();

      cout << " and i: " << i.GetItsVal() << endl;

      a = i++;

      cout << "The value of a: " << a.GetItsVal();

      cout << " and i: " << i.GetItsVal() << endl;

    return 0;

   }

