    // Listing 10.14

    //Overload operator plus (+)


    typedef unsigned short  USHORT;

    #include <iostream.h>


    class Counter

    {

    public:

      Counter();

      Counter(USHORT initialValue);

      ~Counter(){}

      USHORT GetItsVal()const { return itsVal; }

      void SetItsVal(USHORT x) {itsVal = x; }

      Counter operator+ (const Counter &);

   private:

      USHORT itsVal;

   };


   Counter::Counter(USHORT initialValue):

   itsVal(initialValue)

   {}


   Counter::Counter():

   itsVal(0)

   {}


   Counter Counter::operator+ (const Counter & rhs)

   {

      return Counter(itsVal + rhs.GetItsVal());

   }


   int main()

   {

      Counter varOne(2), varTwo(4), varThree;

      varThree = varOne + varTwo;

      cout << "varOne: " << varOne.GetItsVal()<< endl;

      cout << "varTwo: " << varTwo.GetItsVal() << endl;

      cout << "varThree: " << varThree.GetItsVal() << endl;


    return 0;

   }

